 #############################################################################
 #                                                                           #
 #  Copyright (c) 1991-1994                                                  #
 #  by TreadMarks, L.L.C. (TREADMARKS), Houston, Texas	  		     #
 #                                                                           #
 #  This software is furnished under a license and may be used and  copied   #
 #  only  in  accordance  with  the  terms  of  such  license and with the   #
 #  inclusion of the above copyright notice.  This software or  any  other   #
 #  copies  thereof may not be provided or otherwise made available to any   #
 #  other person.  No title to or ownership of  the  software  is  hereby    #
 #  transferred.                                                             #
 #									     #
 #  The recipient of this software (RECIPIENT) acknowledges and agrees that  #
 #  the software contains information and trade secrets that are	     #
 #  confidential and proprietary to TREADMARKS.  RECIPIENT agrees to take    #
 #  all reasonable steps to safeguard the software, and to prevent its       #
 #  disclosure.								     # 
 #                                                                           #
 #  The information in this software is subject to change  without  notice   #
 #  and should  not  be  construed  as  a commitment by TREADMARKS.	     #
 #                                                                           #
 #  This software is furnished AS IS, without warranty of any kind, either   #
 #  express or implied (including, but not limited to, any implied warranty  #
 #  of merchantability or fitness), with regard to the software.  	     #
 #  TREADMARKS assumes no responsibility for the use or reliability of its   #
 #  software.  TREADMARKS shall not be liable for any special, incidental,   #
 #  or consequential damages, or any damages whatsoever due to causes beyond #
 #  the reasonable control of TREADMARKS, loss of use, data or profits, or   #
 #  from loss or destruction of materials provided to TREADMARKS by	     #
 #  RECIPIENT.								     #
 #									     #
 #  TREADMARKS's liability for damages arising out of or in connection with  #
 #  the use or performance of this software, whether in an action of	     #
 #  contract or tort including negligence, shall be limited to the purchase  #
 #  price, or the total amount paid by RECIPIENT, whichever is less.	     #
 #                                                                           #
 #############################################################################

 #
 # $Id: .common,v 10.4.1.1 1997/12/15 03:00:57 alc Exp $
 #
 # Description:    
 #	builds the ATM and Ethernet libraries
 #
 # Facility:	TreadMarks Distributed Shared Memory System
 # History:
 #	25-Aug-1993	Alan L. Cox	Created
 #
 #	Version 0.9.0
 #
 #	Version 0.9.1
 #
 #	16-Jan-1995	Rob Fowler	Modified for demo version
 #
 #	Version 0.9.2
 #
 #	30-Apr-1995	Alan L. Cox	Eliminated ranlib for Solaris
 #
 #	Version 0.9.3
 #

OBJS	= barrier.o diff.o distribute.o exit.o fort_if.o interval.o lock.o mmap.o page.o repo.o sched.o segv.o sh_malloc.o sigio.o timeout.o

SRC	= $(ROOT)/src

clean:
	rm -f *.c *.o lib*.a timestamp

libTmk_atm.a: open_atm.o $(OBJS) $(MACHDEP_OBJS) startup.o
	$(AR) $(ARFLAGS) $@ $?
	if [ -f /usr/bin/ranlib ] ; then ranlib $@ ; else true ; fi

libTmk_mpl.a: open_mpl.o $(OBJS) $(MACHDEP_OBJS) startup.o
	$(AR) $(ARFLAGS) $@ $?
	if [ -f /usr/bin/ranlib ] ; then ranlib $@ ; else true ; fi

libTmk_udp.a: open_udp.o $(OBJS) $(MACHDEP_OBJS) startup.o getopt.o
	$(AR) $(ARFLAGS) $@ $?
	if [ -f /usr/bin/ranlib ] ; then ranlib $@ ; else true ; fi

libTmk_udp_p.a: open_udp.po $(OBJS:.o=.po) $(MACHDEP_OBJS:.o=.po) startup.po
	$(AR) $(ARFLAGS) $@ $?
	if [ -f /usr/bin/ranlib ] ; then ranlib $@ ; else true ; fi

libTmk_udp_ll.a: open_udp.o $(OBJS) $(MACHDEP_OBJS) ll.o startup_ll.o
	$(AR) $(ARFLAGS) $@ $?
	if [ -f /usr/bin/ranlib ] ; then ranlib $@ ; else true ; fi

barrier.o: $(SRC)/barrier.c
	$(CC) $(CFLAGS) -c $(SRC)/barrier.c

diff.o: $(SRC)/diff.c
	$(CC) $(CFLAGS) -c $(SRC)/diff.c

distribute.o: $(SRC)/distribute.c
	$(CC) $(CFLAGS) -c $(SRC)/distribute.c

exit.o: $(SRC)/exit.c
	$(CC) $(CFLAGS) -c $(SRC)/exit.c

fort_if.o: $(SRC)/fort_if.c
	$(CC) $(CFLAGS) -c $(SRC)/fort_if.c

getopt.o: $(ROOT)/lib.i386_linux2/support/getopt.c
	$(CC) $(CFLAGS) -c $(ROOT)/lib.i386_linux2/support/getopt.c

interval.o: $(SRC)/interval.c
	$(CC) $(CFLAGS) -c $(SRC)/interval.c

ll.o: $(SRC)/ll.c
	$(CC) $(CFLAGS) -c -I$(LL)/include -DLoadL $(SRC)/ll.c

lock.o: $(SRC)/lock.c
	$(CC) $(CFLAGS) -c $(SRC)/lock.c

mmap.o: $(SRC)/mmap.c
	$(CC) $(CFLAGS) -c $(SRC)/mmap.c

mmap.o:	$(ROOT)/include/Tmk_mman.h

open_atm.o: $(SRC)/open_atm.c
	$(CC) $(CFLAGS) -c -I/usr/fore/include $(SRC)/open_atm.c

open_mpl.o: $(SRC)/open_mpl.c
	$(CC) $(CFLAGS) -c $(SRC)/open_mpl.c

open_udp.o: $(SRC)/open_udp.c
	$(CC) $(CFLAGS) -c $(SRC)/open_udp.c

page.o: $(SRC)/page.c
	$(CC) $(CFLAGS) -c $(SRC)/page.c

repo.o: $(SRC)/repo.c
	$(CC) $(CFLAGS) -c $(SRC)/repo.c

sched.o: $(SRC)/sched.c
	$(CC) $(CFLAGS) -c $(SRC)/sched.c

segv.o: $(SRC)/segv.c
	$(CC) $(CFLAGS) -c $(SRC)/segv.c

sh_malloc.o: $(SRC)/sh_malloc.c
	$(CC) $(CFLAGS) -c $(SRC)/sh_malloc.c

sigio.o: $(SRC)/sigio.c
	$(CC) $(CFLAGS) -c $(SRC)/sigio.c

startup.o: $(SRC)/startup.c $(SRC)/open_atm.c $(SRC)/open_udp.c $(OBJS) timestamp
	$(CC) $(CFLAGS) -c -DTIMESTAMP=`./timestamp` $(SRC)/startup.c

startup_ll.o: $(SRC)/startup.c $(SRC)/open_atm.c $(SRC)/open_udp.c $(OBJS) timestamp
	$(CC) $(CFLAGS) -c -DTIMESTAMP=`./timestamp` -I$(LL)/include -DLoadL -o $@ $(SRC)/startup.c

timeout.o: $(SRC)/timeout.c
	$(CC) $(CFLAGS) -c $(SRC)/timeout.c

$(OBJS) $(MACHDEP_OBJS) open_atm.o open_udp.o startup.o startup_ll.o ll.o: $(ROOT)/include/Tmk.h $(SRC)/Tmk.h

rmstartup:
	$(RM) startup.o

timestamp: $(SRC)/timestamp.c
	$(CC) $(CFLAGS) -o $@ $(SRC)/timestamp.c
